#!/usr/bin/env python
from gimpfu import *
import random


HUE_NAMES=["*random"]
HUE_NAMES.extend(["Red (0)", "Red-Orange (15)","Orange (30)", "Orange-Yellow (45)","Yellow (60)", "Yellow-Chartreuse (75)",
                  "Chartreuse (90)", "Chartreuse-Green (105)","Green (120)", "Green-Spring (135)","Spring (150)", "Spring-Cyan (165)",
                  "Cyan (180)", "Cyan-Azure (195)", "Azure (210)", "Azure-Blue (225)", "Blue (240)", "Blue-Violet (255)",
                  "Violet (270)", "Violet-Magenta (285)", "Magenta (300)",  "Magenta-DeepPink (315)", "DeepPink (330)", "DeepPink-Red (345)"])

HUE_HEX=["#7F7F7F"]
HUE_HEX.extend  (["#FF0000", "#FF4000", "#FF8000", "#FFC000", "#FFFF00", "#C0FF00",
                  "#80FF00", "#40FF00", "#00FF00", "#00FF40", "#00FF80", "#00FFC0",
                  "#00FFFF", "#00C0FF", "#0080FF", "#0040FF", "#0000FF", "#4000FF",
                  "#8000FF", "#C000FF", "#FF00FF", "#FF00C0", "#FF0080", "#FF0040"])
############################################################################################################################################

def HTMLColorToRGB(colorstring):
    """ convert #RRGGBB to an (R, G, B) tuple """
    colorstring = colorstring.strip()
    if colorstring[0] == '#': colorstring = colorstring[1:]
    if len(colorstring) != 6:
        raise ValueError, "input #%s is not in #RRGGBB format" % colorstring
    r, g, b = colorstring[:2], colorstring[2:4], colorstring[4:]
    r, g, b = [int(n, 16) for n in (r, g, b)]
    return (r, g, b)
############################################################################

def Leave1Hue(inImage, inDrawable, inHue):
    
    pdb.gimp_context_push
    pdb.gimp_context_set_sample_criterion (SELECT_CRITERION_H)  # criterion = HUE
    pdb.gimp_context_set_sample_threshold (0.15)
    pdb.gimp_image_undo_group_start (inImage)
    
    if inHue == 0:  # random
        inHue = random.randrange (1, len(HUE_NAMES))

    htmlcolor = HUE_HEX[inHue]
    rgb = HTMLColorToRGB(htmlcolor)
    
    pdb.gimp_image_select_color (inImage, CHANNEL_OP_REPLACE, inDrawable, rgb)
    pdb.gimp_selection_invert (inImage)
    pdb.gimp_desaturate (inDrawable)
    pdb.gimp_selection_none (inImage)
    pdb.gimp_image_undo_group_end (inImage)
    pdb.gimp_context_pop
    pdb.gimp_displays_flush()
    return()
    
register(
    "Leave1Hue",    "Leave1Hue",    "Leave1Hue",
    "Diego",     "Diego Nassetti ",     "2017",
    "Leave1Hue",
    "RGB*",
    [
      (PF_IMAGE, "image", "Input image", None),
      (PF_DRAWABLE, "idrawable", "Input drawable", None),
      (PF_OPTION, "hue", "Choose a hue:", 0, HUE_NAMES),
    ],
    [],
    Leave1Hue,
    menu="<Image>/Diego/Ancillary",
    )

main()
